<?php

 define("INFO_MODE", 1);
 define("SOURCE_MODE", 2);

 $mode = 0;

    // For INFO_MODE
 $value_arg = false;
 $name_arg = "name";

 if (isset($_GET['menu'])){
    $menu = true;
 }else{
    $menu = false;
 }
 try{
    switch($_GET['target']){
	case 'servers':
	    echo getList($_POST);
	break;
	case 'registerNewMask':
	    $maskManager = new MaskManager();
	    $maskManager->registerNewMask($_POST["maskElementsJson"]);
	break;
    }
 }catch(ADEIException $ex){
    $ex->logInfo(NULL, $reader?$reader:$req);
    $error = xml_escape($ex->getInfo());
    echo $error;
 }
 class MaskManager{
    function MaskManager(){
    }
    function registerNewMask($jsonString){
	$jsonObj = json_decode($jsonString);
	$t = array();
	$IDs = $jsonObj->IDs;
	foreach($IDs as $item){
	    array_push($t, $this->splitPath($item));
	}
	print_r($t);
    }
    function splitPath($path){
	$ret;
	$ret["fullPath"] = $path;
	$ret["element"] = basename($path);
	$ret["dBGroupName"] = basename(dirname($path));
	$ret["dBName"] = basename(dirname(dirname($path)));
	$ret["dBServerName"] = basename(dirname(dirname(dirname($path))));
	array_multisort($ret);
	return $ret;
    }
 }
 function getList($post){
    $globalTreeNode = "servers";
    $path = $post['node'];
    $pathInfo = pathinfo($path);
    $depth = 0;
    $dirName = dirname($path);
    while($dirName != "."){
        $depth++;
        $dirName = dirname($dirName);
    }
    try{
	switch($depth){
	    case 0:
	    // Server
		$req = new REQUEST($_GET);
		$list = $req->GetServerList();
		$listArray = array();
		foreach($list as $db){
		    $node = '{"text":"'.$db["name"].'", "id":"'.$path.'\/'.$db["db_server"].'", "cls":"folder", "leaf":false}';
		    array_push($listArray, $node);
		}
		$jsonString = "[".implode(",", $listArray)."]";
	    break;
	    case 1:
            // Databases
		$dbServerName = basename($path);
		$a = array ('db_server' => $dbServerName);
		$srvreq = new SERVERRequest($a);
		$dbList = $srvreq->GetDatabaseList();
		$listArray = array();
		foreach($dbList as $db){
		    $node = '{"text":"'.$db["name"].'", "id":"'.$globalTreeNode.'\/'.$dbServerName.'\/'.$db["db_name_name"].'", "leaf":false, "cls":"folder"}';
		    array_push($listArray, $node);
		}
		$jsonString = "[".implode(",", $listArray)."]";
	    break;
	    case 2:
	    // Group
		$dBName = basename($path);
		$dBServerName = basename(dirname($path));
		$a = array(
		    'db_server' => $dBServerName,
		    'db_name' => $dBName,
		);
		$groupSourceReq = new SOURCERequest($a);
		$groupList = $groupSourceReq->GetGroupList();
		//print_r($groupList);
		reset($groupList);
		$listArray = array();
		foreach($groupList as $group){
		    $node = '{"text":"'.$group["name"].'", "id":"'.$globalTreeNode.'\/'.$dBServerName.'\/'.$dBName.'\/'.$group["gid"].'", "leaf":false, "cls":"folder"}';
		    array_push($listArray, $node);
		}
		$jsonString = "[".implode(",", $listArray)."]";
	    break;
	    case 3:
	    // Time Series
		$dBGroupName = basename($path);
		$dBName = basename(dirname($path));
		$dBServerName = basename(dirname(dirname($path)));
		$a = array(
		    'db_server' => $dBServerName,
		    'db_name' => $dBName,
		    'db_group' => $dBGroupName
		);
		$dbreq = new GROUPRequest($a);
		$itemsList = $dbreq->GetItemList();
		$listArray = array();
		foreach($itemsList as $item){
		    $node = '{"text":"'.$item["name"].'", "id":"'.$globalTreeNode.'\/'.$dBServerName.'\/'.$dBName.'\/'.$dBGroupName.'\/'.$item["id"].'", "leaf":true, "cls":"leaf", "checked": false}';
		    array_push($listArray, $node);
		}
		$jsonString = "[".implode(",", $listArray)."]";
	    break;
	    default:
            echo "default case: ".$depth;
	}
    }catch(ADEIException $ex){
	$ex->logInfo(NULL, $reader?$reader:$req);
	$error = xml_escape($ex->getInfo());
	//echo $error;
	$jsonString = '[{"text":"Error:'.$error.'", "id":"servers\/katrindb\/information_schema", "cls":"leaf", "leaf":true}]';
    }
    return $jsonString;
 }
?>