USE usersArea;
DROP TABLE IF EXISTS `masks`;
CREATE TABLE `masks` (
    `title` CHAR(128) NOT NULL PRIMARY KEY,
    `userid` CHAR(128) NULL,
    `description` TEXT,
    `dateOfCreation` TIMESTAMP,
    `numberOfElements` INT,
    `numberOfGroups` INT,
    `config` TEXT,
    INDEX iuser (userid)
);
DROP TABLE IF EXISTS `vgElements`;
CREATE TABLE `vgElements` (
    `title` CHAR(128) NOT NULL,
    `postfix` CHAR(128) NOT NULL,
    `itemids` TEXT NOT NULL,
    `axisids` TEXT NOT NULL,
    `scaleids` TEXT NULL,
    UNIQUE INDEX (title, postfix)
);
