Ext.BLANK_IMAGE_URL = '../includes/ext/resources/images/default/s.gif';


function getGETVariable(variable) {
    query = window.location.search.substring(1);
    vars = query.split("&");
    for (var i=0;i<vars.length;i++) {
	pair = vars[i].split("=");
	if (pair[0] == variable) {
	    return pair[1];
	}
    }
    return "";
}
var setup = getGETVariable('setup');
if(setup.length != 0){
    var serverPhpUrl = "../services/ui_server.php?setup=" + setup;
}else{
    var serverPhpUrl = "../services/ui_server.php?";
}
Ext.onReady(function(){

    var treeJson = [{
	text:'Virtual Groups Operations',
	id: 'vGroupOperations',
	expanded: true,
	children:[{
	    text: 'Channel Editor',
	    id: 'createNewVGroup',
	    leaf:true
	},{
	    text:'Group Manager',
	    id:'manageVGroups',
	    leaf:true
	}]
    },{
	text:'Axis Manager',
	children:[{
	    text:'Create New Axis',
	    id:'createNewAxis',
	    leaf:true
	},{
	    text:'Manage Axis',
	    id:'manageAxis',
	    leaf:true
	}]
    },{
	text:'Generate Document',
	children:[{
	    text:'From Template',
	    id:'fromTemplate',
	    leaf:true
	},{
	    text:'Blank',
	    id:'blank',
	    leaf:true
	}]
    },{
	text: 'logout',
	id: 'logout',
	iconCls: 'logout',
	leaf: true,
    }];


    var navigationTreePanel = new Ext.tree.TreePanel({
        id: 'navigation-tree-panel',
        region:'north',
        split: true,
        autoScroll: true,
        // tree-specific configs:
        rootVisible: false,
        lines: false,
	border: false,
        singleExpand: true,
        useArrows: false,

        loader: new Ext.tree.TreeLoader(),

        root: new Ext.tree.AsyncTreeNode({
	    text: 'navigationMenu',
	    draggable:false,
	    id:'navigationMenu',
	    children: treeJson
	})
    });
    navigationTreePanel.on('click', function(node){
        var sn = this.selModel.selNode || {}; // selNode is null on initial selection
        if(node.leaf && node.id != sn.id){  // ignore clicks on folders and currently selected node
	    if(node.id == 'logout'){
		Ext.MessageBox.confirm(
		    'Confirm',
		    'Are you sure, you want to log out ?',
		    function(btn){
		        switch(btn){
		            case "yes":
		                window.location = "login.html";
		            break;
		            case "no":
		            break;
		            default:
		                alert("Something wrong default case ...");
		        }
		    }
		)

		
	    }
	    centerPanel.setTitle(node.text);
            Ext.getCmp('content-panel').layout.setActiveItem(node.id + '-panel');
        }
    });

    var leftPanel = new Ext.Panel({
	title: 'Tools',
	collapsible: true,
	region:'west',
	width: 200,
	items: [
	    navigationTreePanel
	]
    });

    var topPanel = new Ext.Panel({
	title: 'Top Panel',
	id: 'topPanel',
	region: 'north',
	height: 100
    });

    var contentPanel = {
        id: 'content-panel',
        region: 'center', // this is what makes this panel into a region within the containing layout
        layout: 'card',
        margins: '2 5 5 0',
	width: 1000,
	autoScroll: true,
        activeItem: 0,
        border: false,
        items: [
	    startPanel,
	    manageVGroupsPanel,
	    createNewVGroupPanel,
	    manageAxisPanel,
	    createNewAxisPanel,
        ]
    };
    var centerPanel = new Ext.Panel({
	title: ' - ',
	id: 'centerPanel',
	//layout: 'card',
	region: 'center',
	items:[contentPanel]
    });
    var bottomPanel = new Ext.Panel({
	title: 'Bottom Panel',
	height: 50,
	region: 'south'
    });

    var mainContainer = new Ext.Viewport({
	layout: 'border',
	renderTo: document.body,
	items: [
	    leftPanel,
	    //topPanel,
	    centerPanel,
	    bottomPanel
	]
    });
})
