/*
 * ================  AnbsoluteLayout config  =======================
 */
    var elementsInGroup = [];
    var storeDataArray = [];
    var currentTimeSeriesInGrid = [];
    var TreeTimeSeries = Ext.tree;
    var treeTimeSeries = new TreeTimeSeries.TreePanel({
	title: "Channels",
	height: 452,
	width: 300,
//        useArrows:true,
        autoScroll:true,
        animate:true,
//      containerScroll: true,
	border: true,
	frame: true,
	//pathSeparator: '^',
        loader: new TreeTimeSeries.TreeLoader({
            dataUrl: serverPhpUrl + '&target=servers',
	    //preloadChildren: true
	    //baseAttrs: {checked: false}
	    listeners: {
		"load": {
		    fn: function(treeLoader, node){
			this.baseParams.Axis = node.attributes.Axis;
			node.eachChild(
			    function(currentChild){
				currentChild.attributes.Axis;
			    }
			);
		    }
		}
	    }
        }),
	tbar:[
	    {
		text: 'Add',
		iconCls: 'add',
		handler: addSelectedTimeSeriesToGrid
	    }
	]
    });
/*
    treeTimeSeries.on(
	"beforeload", 
	function(treeLoader, node) {
	    this.baseParams.Axis = node.attributes.Axis;
	}, 
	this
    );
*/    function addSelectedTimeSeriesToGrid(){
	checkedNodes = treeTimeSeries.getChecked();
	if(checkedNodes.length == 0){
	    Ext.Msg.alert('Info', 'Please, select channels from the tree.');
	}
	//alert(checkedNodes);
	tempArray = [];
	tempArrayAssociative = [];
	storeDataArray = [];
	newElementsInGroup = [];
	currentTimeSeriesInGrid = [];
	for(i=0; i<checkedNodes.length; i++){
	    //alert(checkedNodes[i].getPath());
	    elementsInGroup[elementsInGroup.length] = checkedNodes[i];
	    axis = myData[checkedNodes[i].attributes.Axis][1];
	    currentTimeSeriesInGrid[i] = checkedNodes[i].id;
	    ChannelName = checkedNodes[i].text;
	    GroupName = checkedNodes[i].parentNode.text;
	    DatabaseName = checkedNodes[i].parentNode.parentNode.text;
	    ServerName = checkedNodes[i].parentNode.parentNode.parentNode.text;
	    iDpath = ServerName + "/" + DatabaseName + "/" + GroupName + "/" + ChannelName;
	    Color = "#f0f0f0";
	    treeId = checkedNodes[i].id;
	    oneLineArray = [i, ServerName, DatabaseName, GroupName, ChannelName, Color, axis, treeId];
	    tempArray[tempArray.length] = iDpath;
	    tempArrayAssociative[iDpath] = oneLineArray;
	    //storeDataArray[storeDataArray.length] = oneLineArray;
	    parent = checkedNodes[i].parentNode;
	    checkedNodes[i].disable();
	    if(parent.length){
		while(!parent.hasChildNodes()){
		    if(!parent.hasChildNodes()){
			currentParent = parent;
			parent = currentParent.parentNode;
			currentParent.disable();
		    }
		}
	    }
	}
	tempArray.sort();
	for(i=0; i<tempArray.length; i++){
	    storeDataArray[i] = tempArrayAssociative[tempArray[i]];
	    storeDataArray[i][0] = i;
	    newElementsInGroup[i] = elementsInGroup[storeDataArray[i][0]];
	}
	var elemeentsInGroup = newElementsInGroup;
	//alert(storeDataArray);
	store.removeAll()
	store.loadData(storeDataArray);
    }
    function removeAllFromGrid(){
	for(i=0; i<elementsInGroup.length; i++){
	    elementsInGroup[i].enable();
	    elementsInGroup[i].getUI().toggleCheck();
	}
	elementsInGroup = [];
	storeDataArray = [];
	store.loadData(storeDataArray);
    }
    function loadVGroupForEdit(json){
	tmpArray = treeTimeSeries.getChecked();
	if(tmpArray.length != 0){
	    Ext.MessageBox.confirm(
		'Confirm',
		'Drop the changes in "Create New Virtual Group" area ?',
		function(btn){
		    if(btn == "yes"){
			loadVGroupElementsForEdit(json);
		    }
		}
	    );
	}else{
	    loadVGroupElementsForEdit(json);
	}
    }
    function loadVGroupElementsForEdit(json){
	removeAllFromGrid();
	// Uncheck all the nodes in the left tree
	checkedNodes = treeTimeSeries.getChecked();
	for(i=0; i<checkedNodes.length; i++){
	    checkedNodes[i].getUI().toggleCheck();
	}
	createNewVGroupPanel.form.findField("vGroupId").setRawValue(json.vGroupId);
	createNewVGroupPanel.form.findField("vGroupName").setRawValue(json.vGroupName);
	pathsArray = new Array();
	for(i=0; i<json.IDs.length; i++){
	    iD = json.IDs[i];
	    //alert(iD);
	    iDArray = iD.split('^');
	    path = '';
	    for(j=1; j<iDArray.length; j++){
		element = '';
		for(k=0; k<j; k++){
		    if(k < j - 1){
			element += iDArray[k] + '^';
		    }else{
			element += iDArray[k];
		    }
		}
		path += '/' + element;
	    }
	    pathsArray.push(path);
	}
	pathsArray = unique(pathsArray);
	numberOfLoadedElements = 0;
	for(i=0; i<pathsArray.length; i++){
	    //alert("expanding: " + pathsArray[i]);
	    treeTimeSeries.expandPath(
		pathsArray[i],
		'',
		function(success, lastNode){
		    numberOfLoadedElements++
		    if(numberOfLoadedElements == pathsArray.length){
			for(j=0; j<json.IDs.length; j++){
			    treeTimeSeries.getNodeById(json.IDs[j]).getUI().toggleCheck(true);
			}
			addSelectedTimeSeriesToGrid();
			setAxisOfGrid(json);
		    }
		}
	    );
	}
    }
    function setAxisOfGrid(json){
	//alert(storeDataArray);
	out = "";
	for(i=0; i<json.IDs.length; i++){
	    for(j=0; j<storeDataArray.length; j++){
		if(storeDataArray[j][7] == json.IDs[i]){
		    storeDataArray[j][6] = myData[json.AxisIds[i]][1];
		    store.removeAll()
		    store.loadData(storeDataArray);
		}
	    }
	}
    }

    function saveTimeSeriesfunction(saveType){
	checkedNodes = treeTimeSeries.getChecked();
	saveType = saveType || "Save";
	if(checkedNodes.length == 0){
	    Ext.MessageBox.alert('Failed', 'Please add channels to the grid.');
	    return;
	}
	if(createNewVGroupPanel.form.findField("vGroupId").getValue().length == 0 || createNewVGroupPanel.form.findField("vGroupId").getValue() == 'auto'){
		date = new Date();
		vGroupId = date.getTime()%10000;
		createNewVGroupPanel.form.findField("vGroupId").setValue(vGroupId);
	}
	if(createNewVGroupPanel.form.findField("vGroupName").getValue() == 0){
	    Ext.MessageBox.alert('Failed', 'Virtual Group Name is required.');
	    return;
	}
	var jsonObj = {
	    "IDs":[],
	    "Axis":[],
	    "vGroupId": "",
	    "vGroupName": "",
	    "saveType": saveType
	};
	store.each(
	    function(record){
		columnName = record.get("Column");
		jsonObj.IDs.push(record.get("treeId"));
		jsonObj.Axis.push(parseInt(axisAssociativeArray[record.get("Axis")]));
	    }
	);
	jsonObj.vGroupId = createNewVGroupPanel.form.findField("vGroupId").getValue();
	jsonObj.vGroupName = createNewVGroupPanel.form.findField("vGroupName").getValue();
	encodedJson = Ext.util.JSON.encode(jsonObj);
	Ext.Ajax.request({
	    url : serverPhpUrl + '&target=registerNewMask',
	    params : {
		"maskElementsJson": encodedJson
	    },
	    method: 'POST',
	    timeout: 60000,
	    success: function ( result, request ) {
		jsonAckObj = Ext.util.JSON.decode(result.responseText);
		if(jsonAckObj.Code == "Exists"){
		    Ext.MessageBox.confirm(
			'Confirm',
			'The Virtual Group with the given ID already exists, do you want to update it ?',
			function(btn){
			    switch(btn){
				case "yes":
				    saveTimeSeriesfunction("Update");
				break;
				case "no":
				break;
				default:
				    alert("Something wrong default case ...");
			    }
			}
		    )
		}else{
		    //alert(jsonAckObj.Message);
		    MasksDataStore.reload();
		    Ext.MessageBox.alert('', jsonAckObj.Message);
		}
	    },
	    failure: function ( result, request) {
		Ext.MessageBox.alert('Info', result.responseText);
	    }
	});
    }

    // set the root node
    var root = new TreeTimeSeries.AsyncTreeNode({
        text: 'Channels',
        draggable:false,
        id:'servers'
    });
    treeTimeSeries.setRootNode(root);
    Ext.state.Manager.setProvider(new Ext.state.CookieProvider());



    // example of custom renderer function
    function change(val){
        if(val > 0){
            return '<span style="color:green;">' + val + '</span>';
        }else if(val < 0){
            return '<span style="color:red;">' + val + '</span>';
        }
        return val;
    }

    // example of custom renderer function
    function pctChange(val){
        if(val > 0){
            return '<span style="color:green;">' + val + '%</span>';
        }else if(val < 0){
            return '<span style="color:red;">' + val + '%</span>';
        }
        return val;
    }
    var gridAxisEditorStore = new Ext.data.SimpleStore({
		    fields: ['abbr', 'axes']
    });

    var channelsColumnModel = new Ext.grid.ColumnModel([
	{
	    header: 'ID',
	    dataIndex: 'ID',
	    width: 20
	},{
	    header: 'Server',
	    dataIndex: 'Server',
	    width: 100
	},{
	    header: 'Database',
	    dataIndex: 'Database',
	    width: 100
	},{
	    header: 'Group',
	    dataIndex: 'Group',
	    width: 100
	},{
	    header: 'Channel',
	    dataIndex: 'Channel',
	    width: 150
	},{
	    header: 'Color',
	    dataIndex: 'Color',
	    width: 100,
	    hidden: true
	},{
	    header: 'Axis',
	    dataIndex: 'Axis',
	    width: 150,
	    id: 'Axis',
	    editor: new Ext.form.ComboBox({
		store: gridAxisEditorStore,
		displayField:'abbr',
		typeAhead: true,
		mode: 'local',
		triggerAction: 'all',
		emptyText:'Select axes',
		lazyRender:true,
		selectOnFocus:true
	    })
	},{
	    header: 'treeId',
	    dataIndex: 'treeId',
	    width: 100,
	    hidden: true
	}
    ]);

    // create the data store
    var store = new Ext.data.SimpleStore({
        fields: [
	    {name: 'ID', type: 'int'},
	    {name: 'Server', type: 'string'},
	    {name: 'Database', type: 'string'},
	    {name: 'Group', type: 'string'},
	    {name: 'Channel', type: 'string'},
	    {name: 'Color', type: 'string'},
	    {name: 'Axis', type: 'string'},
	    {name: 'treeId', type: 'string'}
        ],
	sortInfo:{field: 'ID', direction: "ASC"}
    });
    var storeDataArray = [];
    store.loadData(storeDataArray);

    // create the Grid

    var grid = new Ext.grid.EditorGridPanel({
	id: 'maskElementsGrid',
	title:'Virtual Group Elements',
	border: true,
	frame: true,
	store: store,
	colModel: channelsColumnModel,
	selModel: new Ext.grid.RowSelectionModel({singleSelect:false}),
	height:400,
	width: 670,
	tbar: [
	    {
		text: 'Remove Selected',
		iconCls: 'remove',
		handler: function(){
		    selectedNodes = grid.selModel.getSelections();
		    iDOfSelectedNodes = [];
		    for(i = 0; i< selectedNodes.length; i++){
			iDOfSelectedNodes.push(selectedNodes[i].get("ID"));
		    }
		    newStoreDataArray = [];
		    newElementsInGroup = [];
		    for(i=0; i<storeDataArray.length; i++){
			exists = false;
			for(j=0; j<iDOfSelectedNodes.length; j++){
			    if(iDOfSelectedNodes[j] == storeDataArray[i][0]){
				exists = true;
				break;
			    }
			}
			if(!exists){
			    newStoreDataArray.push(storeDataArray[i]);
			    newElementsInGroup.push(elementsInGroup[i]);
			}else{
			    //rootNode = treeTimeSeries.getRootNode();
			    node = treeTimeSeries.getNodeById(storeDataArray[i][7]);
			    node.enable();
			    node.getUI().toggleCheck();
			}
		    }
		    for(i=0; i<newStoreDataArray.length; i++){
			newStoreDataArray[i][0] = i;
		    }
		    storeDataArray = newStoreDataArray;
		    elementsInGroup = newElementsInGroup;
		    store.loadData(storeDataArray);
		    //alert(iDOfSelectedNodes);
		}
	    },{
		text: 'Remove All',
		iconCls: 'removeAll',
		handler: removeAllFromGrid
	    },{
		text: 'Save',
		iconCls: 'save',
		handler: function(){
		    saveTimeSeriesfunction("Save");
		}
	    }
	]
    });

    var createNewVGroupPanel = new Ext.FormPanel({
        id: 'createNewVGroup-panel',
	//width: 1000,
	//height: 600,
	border: false,
	frame: false,
	autoScroll: true,
        items:[{
	    layout: 'column',
	    border: false,
	    frame: true,
	    items:[
		{
		    columnWidth: .4,
		    baseCls:'x-plain',
		    layout: 'form',
		    bodyStyle:'padding:5px 0 5px 5px',
		    items: [
			    treeTimeSeries
		    ]
		},{
		    columnWidth: .6,
		    baseCls:'x-plain',
		    layout: 'form',
		    bodyStyle:'padding:5px 0 5px 5px',
		    items:[
			{
			    id: 'vGroupName',
			    xtype:'textfield',
			    fieldLabel: 'Name',
			    name: 'vGroupName',
			    allowBlank:false
			},{
			    id: 'vGroupId',
			    xtype:'textfield',
			    fieldLabel: 'ID',
			    name: 'vGroupId',
			    allowBlank:false,
			    emptyText: 'auto'
			},
			    grid
		    ]
		}
	    ],
	    tbar: [
		{
		    text: 'Save',
		    iconCls: 'save',
		    handler: function(){
			saveTimeSeriesfunction("Save");
		    }
		},{
		    text: 'New',
		    iconCls: 'new',
		    height: 50,
		    handler: function(){
			if(createNewVGroupPanel.form.findField("vGroupId").getRawValue().length == 0 && createNewVGroupPanel.form.findField("vGroupName").getRawValue().length == 0 && store.getCount() == 0){
			    return;
			}
			Ext.MessageBox.confirm(
			    'Confirm',
			    'Drop current content ?',
			    function(btn){
				switch(btn){
				    case "yes":
					createNewVGroupPanel.form.findField("vGroupId").setRawValue("");
					createNewVGroupPanel.form.findField("vGroupName").setRawValue("");
					removeAllFromGrid();
				    break;
				    case "no":
				    break;
				    default:
					alert("Something wrong default case ...");
				}
			    }
			)
		    }
		},


	    ]
	}]
    });
