<?php
class ElementsManagerClass{
 var $ack;

 function elementsManager(){
    
 }
 function getList($post){
    $globalTreeNode = "servers";
    $path = $post['node'];
    $pathInfo = pathinfo($path);
    $depth = 0;
    $path_array = split('\^', $path);
    $depth = sizeof($path_array);
/*    $dirName = dirname($path);
    while($dirName != "."){
        $depth++;
        $dirName = dirname($dirName);
    }
*/
    try{
        switch($depth){
            case 1:
            // Server
                $req = new REQUEST($_GET);
                $list = $req->GetServerList();
                $listArray = array();
                foreach($list as $db){
                    $node = '{"text":"'.$db["name"].'", "id":"'.$path.'^'.$db["db_server"].'", "cls":"folder", "leaf":false}';
                    array_push($listArray, $node);
                }
                $jsonString = "[".implode(",", $listArray)."]";
            break;
            case 2:
            // Databases
                $dbServerName = $path_array[1];
                $a = array ('db_server' => $dbServerName);
                $srvreq = new SERVERRequest($a);
                $dbList = $srvreq->GetDatabaseList();
                $listArray = array();
                foreach($dbList as $db){
                    $node = '{"text":"'.$db["name"].'", "id":"'.$globalTreeNode.'^'.$dbServerName.'^'.$db["db_name_name"].'", "leaf":false, "cls":"folder"}';
                    array_push($listArray, $node);
                }
                $jsonString = "[".implode(",", $listArray)."]";
            break;
            case 3:
            // Group
                $dBName = $path_array[2];
                $dBServerName = $path_array[1];
                $a = array(
                    'db_server' => $dBServerName,
                    'db_name' => $dBName,
                );
                $groupSourceReq = new SOURCERequest($a);
                $groupList = $groupSourceReq->GetGroupList();
                //print_r($groupList);
                reset($groupList);
                $listArray = array();
                foreach($groupList as $group){
                    $node = '{"text":"'.$group["name"].'", "id":"'.$globalTreeNode.'^'.$dBServerName.'^'.$dBName.'^'.$group["gid"].'", "leaf":false, "cls":"folder"}';
                    array_push($listArray, $node);
                }
                $jsonString = "[".implode(",", $listArray)."]";
            break;
            case 4:
            // Time Series
                $dBGroupName = $path_array[3];
                $dBName = $path_array[2];
                $dBServerName = $path_array[1];
                $a = array(
                    'db_server' => $dBServerName,
                    'db_name' => $dBName,
                    'db_group' => $dBGroupName
                );
                $dbreq = new GROUPRequest($a);
                $itemsList = $dbreq->GetItemList();
                $listArray = array();
                foreach($itemsList as $item){
                    $node = '{"text":"'.$item["name"].'", "id":"'.$globalTreeNode.'^'.$dBServerName.'^'.$dBName.'^'.$dBGroupName.'^'.$item["id"].'", "leaf":true, "cls":"leaf", "checked": false, "Axis": 0}';
                    array_push($listArray, $node);
                }
                $jsonString = "[".implode(",", $listArray)."]";
            break;
            default:
            echo "default case: ".$depth;
        }
    }catch(ADEIException $ex){
        $ex->logInfo(NULL, $reader?$reader:$req);
        $error = xml_escape($ex->getInfo());
        //echo $error;
        $jsonString = '[{"text":"Error:'.$error.'", "id":"servers/katrindb/information_schema", "cls":"leaf", "leaf":true}]';
    }
    $this->ack =  $jsonString;
 }
 function getAck(){
    return $this->ack;
 }
}
?>