Ext.BLANK_IMAGE_URL = './Includes/Ext/resources/images/default/s.gif';

Ext.onReady(function(){
    var adeiEditor = new Ext.FormPanel({
	url:'./server.php?Action=loginValidation',
        labelAlign: 'top',
        frame: true,
	//collapsed: false,
        title: 'Edit Document',
        bodyStyle:'padding:5px 5px 0',
	region: 'center',
        items: [
	    {
                xtype:'textfield',
                fieldLabel: 'Document Title',
                name: 'first',
                anchor:'95%'
            },{
                xtype:'textfield',
                fieldLabel: 'Another Field',
                name: 'last',
                anchor:'95%'
            },{
        	//xtype:'htmleditor',
		xtype:'fckeditor',
		name:'doc2',
		id:'doc2',
		fieldLabel:'Content',
		height: 600
	}],

        buttons: [{
            text: 'Save as Document',
                formBind: true,
                // Function that fires when user clicks the button
                handler:function(){
                    adeiEditor.getForm().submit({
                        method:'POST',
                        waitTitle:'Connecting',
                        waitMsg:'Sending data...',
                        success:function(){
				Ext.Msg.alert('Message', 'Document saved successfuly');
                        },
                        failure:function(form, action){
                                Ext.Msg.alert('Warning!', 'Server is unreachable: ');
                        }
                    });
                }
        },{
            text: 'Preview'
        },{
            text: 'Save as Template'
        },{
            text: 'Cancel'
        },{
            text: 'Drop Document',
            handler:function(){
		adeiEditor.form.findField('doc2').clearContent();
	    }
        },{
            text: 'testButton1',
            handler:function(){
		adeiEditor.form.findField('doc2').setValue('<img src="./temp/bigImages/dog01.jpg" alt="" />');
	    }
        },{
	    text: 'testButton2',
            handler:function(){
		//alert(adeiEditor.form.findField('doc2').getValue());
		//adeiEditor.form.findField('doc2').setValue("aaa");
		alert(adeiEditor.form.findField('doc2').getValue());
		
	    }
	}]
    });

    var xd = Ext.data;
    var store = new Ext.data.JsonStore({
        url: 'get-images.php',
        root: 'images',
        fields: ['name', 'url', {name:'size', type: 'float'}, {name:'lastmod', type:'date', dateFormat:'timestamp'}]
    });
    store.load();
    var tpl = new Ext.XTemplate(
                '<tpl for=".">',
            '<div class="thumb-wrap" id="{name}">',
                    '<div class="thumb"><img src="{url}" title="{name}"></div>',
                    '<span class="x-editable">{shortName}</span></div>',
        '</tpl>',
        '<div class="x-clear"></div>'
    );

    var myPlots = new Ext.Panel({
	title: 'My Plots',
	height: 173,
	autoScroll:true,
        items: new Ext.DataView({
            store: store,
            tpl: tpl,
            autoHeight:true,
            multiSelect: true,
            overClass:'x-view-over',
            itemSelector:'div.thumb-wrap',
            emptyText: 'No images to display',

            plugins: [
                new Ext.DataView.DragSelector(),
                new Ext.DataView.LabelEditor({dataIndex: 'name'})
            ],

            prepareData: function(data){
                data.shortName = Ext.util.Format.ellipsis(data.name, 15);
                data.sizeString = Ext.util.Format.fileSize(data.size);
                data.dateString = data.lastmod.format("m/d/Y g:i a");
                return data;
            },
            listeners: {
		selectionchange: {
		    fn: function(dv,nodes){
			for(i=0; i<nodes.length;i++){
			    imageUrl = "./temp/bigImages/" + nodes[i].id;
			    adeiEditor.form.findField('doc2').addImage(imageUrl);
			}
			
			var l = nodes.length;
			var s = l != 1 ? 's' : '';
			//panel.setTitle('Simple DataView ('+l+' item'+s+' selected)');
		    }
		}
            }
        })

    });
    var myTemplates = new Ext.Panel({
	title: 'My Templates',
	height: 173,
    });
    var myDocuments = new Ext.Panel({
	title: 'My Documents',
	height: 173,
    });

    var leftAccordion = new Ext.Panel({
	region: 'west',
	margins:'0 0 0 0',
	split:true,
	width: 520,
	height: 600,
	layout:'accordion',
	items: [
	    myPlots,
	    myTemplates,
	    myDocuments
    ]
    });

    var body = new Ext.Panel({
	//width: 796,
	height: 780,
	layout: 'border',
	renderTo: document.body,
	items: [
	    adeiEditor,
	    leftAccordion
	]
    });

    //adeiEditor.render(document.body);
})
